import { ref as L, reactive as Z, computed as se, getCurrentInstance as be, toRefs as me, defineComponent as ue, resolveComponent as _, openBlock as c, createBlock as g, withCtx as a, createElementVNode as G, renderSlot as N, createVNode as s, unref as e, createElementBlock as $, Fragment as I, renderList as J, mergeProps as M, createTextVNode as q, toDisplayString as ae, createCommentVNode as z, onMounted as ge, resolveDirective as he, withDirectives as ce, createSlots as ve, resolveDynamicComponent as Fe, normalizeProps as Pe, guardReactiveProps as Ee, vShow as De, isRef as Ve } from "vue";
import { ElMessage as Ce, ElMessageBox as ie, ElNotification as Ae, ElCard as Be, ElButton as X, ElButtonGroup as Me, ElDialog as Se } from "element-plus";
import { useRoute as we } from "vue-router";
const H = L({
  debug: !1,
  mainMaxHeight: 700,
  isAfterMountQuery: !1,
  isOpenSearchForm: !1,
  Form_LabelWidth: 120,
  Dialog_Width: 800,
  Dialog_isFullscreen: !1,
  Dialog_isCloseOnPressEscape: !0,
  Dialog_isCloseOnClickModal: !1,
  Dialog_isFooterButton: !0,
  Table_isOpenIndex: !0,
  Table_isOpenMultipleSelection: !1,
  Table_isOpenExpand: !0,
  Table_ExpandColumn: 4,
  Table_MenuWidth: 310,
  Table_MenuAlign: "left",
  Page_PageSizes: [10, 20, 50, 100],
  Page_PageParams: {
    current: 1,
    pageSize: 10,
    total: 0
  },
  Page_Layout: "->,total, sizes, prev, pager, next, jumper",
  Page_isHideOnSinglePage: !1,
  ApiName: {
    query: "query",
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permission: {
    add: "add",
    edit: "edit",
    delete: "delete",
    deleteFlag: "deleteFlag",
    remove: "remove"
  },
  Permissions: ["add", "edit", "delete", "deleteFlag", "remove"]
}), r = L({
  CompRef: {},
  Mode: "add",
  DialogVisible: !1,
  tableLoading: !1,
  submitLoading: !1,
  DialogVisibleFooterButton: !0,
  ElementArrs: { filter: {}, editor: {}, column: {} },
  tableColumn: [],
  originalData: [],
  tableData: [],
  multipleSelection: [],
  uploadFiles: [],
  initSearchModel: {},
  initEditModel: {},
  searchFormValue: {},
  searchModel: {},
  editFormValue: {},
  editModel: {}
});
function Q(o) {
  let p;
  try {
    p = Array.isArray(o) ? [] : {}, o === null && (p = null);
  } catch {
    p = {};
  }
  for (const t in o)
    typeof o[t] == "object" ? p[t] = Q(o[t]) : p[t] = o[t];
  return p;
}
function te(...o) {
  function p(b) {
    return typeof b == "object" && Object.prototype.toString.call(b) === "[object Object]";
  }
  let t = arguments.length, f = arguments[0];
  p(f) || (f = {});
  for (let b = 1; b < t; b++) {
    let m = arguments[b];
    if (p(m))
      for (let v in m)
        v === "__proto__" || f === m[v] || f.hasOwnProperty(v) && (p(m[v]) ? f[v] = te(f[v], m[v]) : f[v] = m[v]);
  }
  return f;
}
function He(o, p) {
  let t = {}, f = Object.getOwnPropertyNames(o), b = Object.getOwnPropertyNames(p);
  return f.length === b.length && f.forEach((m) => {
    o[m] !== p[m] && (t[m] = p[m]);
  }), t;
}
const Y = {
  beforeSubmitHandler: "beforeSubmitHandler",
  beforedisabledHandler: "beforedisabledHandler",
  afterdisabledHandler: "afterdisabledHandler",
  beforeAddHandler: "beforeAddHandler",
  beforeEditHandler: "beforeEditHandler",
  beforeQueryHandler: "beforeQueryHandler",
  afterQueryHandler: "afterQueryHandler",
  beforeDeteleHandler: "beforeDeteleHandler",
  afterDeteleHandler: "afterDeteleHandler",
  beforeTableLazyHandler: "beforeTableLazyHandler"
};
function Re(o = { debug: !1 }) {
  const p = Z({
    hooks: {}
  });
  return Object.keys(o).forEach((f) => {
    f !== "debug" && (p.hooks[f] = o[f]);
  }), {
    hookHandler: (f, b) => {
      let m = !1;
      try {
        o.debug && (console.group("DeBug\uFF1A", f), console.table(b.Data), console.groupEnd()), m = p.hooks[f](b);
      } catch {
        m = !0;
      }
      return m;
    }
  };
}
let B = {};
const ee = L(), Oe = (o) => {
  ee.value = o.CrudRequest, H.value = te(H.value, o), oe("\u3010\u521D\u59CB\u5316Options\u3011", o), B = { ...H.value };
}, ye = () => {
  const { props: o, slots: p, emit: t, refs: f } = be();
  JSON.stringify(o) !== "{}" && (Te(o.source), H.value = te(H.value, o.source.options), H.value = te(H.value, o), oe("UseCrudStates\u4F20\u53C2\u3010props\u3011", o), oe("\u3010DefParams\u3011", H.value), oe("\u3010CrudStates\u3011", r.value));
  const b = (n) => {
    let d = {};
    return o.rowKey && (d[o.rowKey] = n[o.rowKey]), o.rowKeys && o.rowKeys.forEach((h) => {
      d[h] = n[h];
    }), d;
  }, m = (n, d = "success") => {
    Ae({
      title: n,
      type: d,
      offset: 70,
      duration: 2500
    });
  }, { hookHandler: v } = Re(o.hooks);
  function i() {
    r.value.tableLoading = !0;
    const n = Z({ ...r.value.initSearchModel, ...r.value.searchModel });
    for (const d in n)
      Object.prototype.hasOwnProperty.call(n, d) && typeof n[d] == "string" && (n[d] = n[d].trim(), n[d] === "" && (n[d] = void 0));
    !v(Y.beforeQueryHandler, { CrudState: r, Data: n }) || ee.value({
      url: o.url,
      name: H.value.ApiName.query,
      data: {
        pagenum: H.value.Page_PageParams.current,
        pagesize: H.value.Page_PageParams.pageSize,
        ...n
      }
    }).then((d) => {
      const { data: h, page: S } = d;
      setTimeout(() => {
        F(h, n), H.value.Page_PageParams.total = S.total, r.value.tableLoading = !1;
      }, 50);
    }).catch(() => {
      r.value.tableLoading = !1;
    });
  }
  const F = (n, d) => {
    Object.keys(d).filter((S) => d[S] != null).length == 0 && (r.value.originalData = n), r.value.originalData = Q(n), v(Y.afterQueryHandler, { CrudState: r, Data: n }) && (r.value.tableData = Q(n));
  }, D = () => {
    r.value.searchModel = Q(r.value.initSearchModel);
  }, E = (n) => {
    !n || (n.resetFields(), _e.value.length && _e.value.forEach((d) => {
      const h = d + "UploadRef";
      f[h][0].clearFiles();
    }));
  };
  function C() {
    r.value.editModel = Q(r.value.initEditModel);
    const n = Z({ ...r.value.editModel });
    !v(Y.beforeAddHandler, { CrudState: r, Data: n }) || (r.value.Mode = "add", r.value.DialogVisible = !0);
  }
  const O = (n) => {
    const d = Z({
      ...n
    });
    if (!v(Y.beforeEditHandler, { CrudState: r, Data: d }))
      return;
    const h = Q(d);
    Object.keys(h).forEach((S) => {
      r.value.editModel[S] = h[S], r.value.editFormValue[S] = h[S];
    }), r.value.Mode = "edit", r.value.DialogVisible = !0;
  }, T = async (n) => {
    !n || await n.validate((d) => {
      if (d) {
        const h = Z({
          ...r.value.editModel
        });
        if (!v(Y.beforeSubmitHandler, { CrudState: r, Data: h }))
          return;
        r.value.Mode === "add" ? j(h) : R(h);
      }
    });
  }, j = (n) => {
    r.value.submitLoading = !0;
    let d = n;
    n.FormData instanceof FormData && (d = n.FormData), ee.value({ url: o.url, name: H.value.ApiName.add, data: d }).then(() => {
      r.value.DialogVisible = !1, m("\u65B0\u589E\u6210\u529F"), i(), r.value.submitLoading = !1;
    }).catch(() => {
      r.value.submitLoading = !1;
    });
  }, R = (n) => {
    r.value.submitLoading = !1;
    let d = n;
    if (n.FormData instanceof FormData)
      d = n.FormData;
    else {
      const h = He(r.value.editModel, d);
      if (JSON.stringify(h) === "{}")
        return r.value.submitLoading = !1, Ce({ message: "\u6CA1\u6709\u63D0\u4EA4\u9879\uFF01", grouping: !0 });
      d = {
        ...b(n),
        ...h
      };
    }
    ee.value({ url: o.url, name: H.value.ApiName.edit, data: d }).then(() => {
      r.value.DialogVisible = !1, m("\u7F16\u8F91\u6210\u529F"), i(), r.value.submitLoading = !1;
    }).catch(() => {
      r.value.submitLoading = !1;
    });
  };
  return {
    queryRecord: i,
    refresh: D,
    resetForm: E,
    addRecord: C,
    editRecord: O,
    handleSubmit: T,
    delFlag: (n) => {
      ie.confirm(`\u786E\u5B9A\u8981 \u201C${n.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u201D \u8BE5\u6761\u6570\u636E\u5417\uFF1F`, "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const d = Z({
          row: { ...n },
          ...b(n),
          deleteFlag: n.deleteFlag == 0 ? 1 : 0
        });
        !v(Y.beforedisabledHandler, { CrudState: r, Data: d }) || ee.value({
          url: o.url,
          name: H.value.ApiName.deleteFlag,
          data: d
        }).then(() => {
          m(`\u6570\u636E${n.deleteFlag ? "\u542F\u7528" : "\u7981\u7528"}\u6210\u529F`), i();
        });
      }).catch(() => {
      });
    },
    deleteRecord: (n) => {
      ie.confirm("\u786E\u5B9A\u8981\u5220\u9664\u672C\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const d = Z({
          row: { ...n },
          ...b(n)
        });
        !v(Y.beforeDeteleHandler, { CrudState: r, Data: d }) || ee.value({
          url: o.url,
          name: H.value.ApiName.delete,
          data: d
        }).then(() => {
          m("\u5220\u9664\u6210\u529F"), i();
        });
      }).catch(() => {
      });
    },
    deleteMulRecord: () => {
      ie.confirm("\u786E\u5B9A\u8981\u5220\u9664\u8FD9\u51E0\u6761\u6570\u636E\u5417\uFF1F", "\u63D0\u793A", {
        confirmButtonText: "\u786E\u5B9A",
        cancelButtonText: "\u53D6\u6D88",
        type: "warning"
      }).then(() => {
        const n = r.value.multipleSelection.map((d) => d[o.rowKey]);
        ee.value({
          url: o.url,
          name: H.value.ApiName.remove,
          data: { [o.rowKey]: n, selection: r.value.multipleSelection }
        }).then(() => {
          m("\u6279\u91CF\u5220\u9664\u6210\u529F"), r.value.multipleSelection = [], r.value.CompRef.TableRef.clearSelection(), i();
        });
      }).catch(() => {
      });
    }
  };
};
function ne() {
  return { ...me(H.value) };
}
function W() {
  return { ...me(r.value) };
}
function oe(...o) {
  H.value.debug && console.info("%c\u3010DeBug\u3011", "color:red", ...o);
}
function Te(o) {
  const { filter: p, editor: t, column: f, columns: b } = o;
  let m = {};
  p.forEach((i) => {
    m[i] = b[i].searchDefaultValue, r.value.ElementArrs.filter[i] = b[i];
  }), r.value.initSearchModel = Q(m), r.value.searchModel = Q(r.value.initSearchModel);
  let v = {};
  t.forEach((i) => {
    v[i] = b[i].addDefaultValue, r.value.ElementArrs.editor[i] = b[i];
  }), r.value.initEditModel = Q(v), f.forEach((i) => {
    r.value.ElementArrs.column[i] = b[i];
  });
}
const _e = se(() => {
  let o = [];
  for (const p in r.value.ElementArrs.editor)
    Object.prototype.hasOwnProperty.call(r.value.ElementArrs.editor, p) && r.value.ElementArrs.editor[p].type === "el-upload" && o.push(p);
  return o;
}), Ue = /* @__PURE__ */ ue({
  __name: "SearchForm",
  setup(o) {
    const { Form_LabelWidth: p } = ne(), {
      searchModel: t,
      Mode: f,
      ElementArrs: {
        value: { filter: b }
      }
    } = W(), m = (i) => {
      var F, D;
      return i.range ? (F = i.formProps) != null && F.type ? i.formProps.type + "range" : "daterange" : (D = i.formProps) != null && D.type ? i.formProps.type : "date";
    }, v = (i, F) => {
      if (F === "disabled")
        return typeof i.disabled == "function" ? i.disabled(W, f.value) : !1;
      if (F === "visible")
        return typeof i.visible == "function" ? i.visible(W, f.value) : !0;
    };
    return (i, F) => {
      const D = _("el-input"), E = _("el-form-item"), C = _("el-col"), O = _("el-input-number"), T = _("el-option"), j = _("el-select"), R = _("el-date-picker"), x = _("el-time-picker"), U = _("el-radio"), k = _("el-radio-button"), n = _("el-radio-group"), d = _("el-row"), h = _("el-form"), S = _("el-collapse-transition");
      return c(), g(S, null, {
        default: a(() => [
          G("div", null, [
            N(i.$slots, "search-form", {}, void 0, !0),
            s(h, {
              model: e(t),
              "label-width": e(p)
            }, {
              default: a(() => [
                s(d, null, {
                  default: a(() => [
                    N(i.$slots, "search-form-top", {}, void 0, !0),
                    (c(!0), $(I, null, J(e(b), (u, A) => {
                      var le;
                      return c(), $(I, null, [
                        u.type === "el-input" ? (c(), g(C, {
                          key: 0,
                          span: u.span ? u.span : 6
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(D, M({
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  clearable: "",
                                  placeholder: "\u6A21\u7CCA\u67E5\u627E"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-input-number" ? (c(), g(C, {
                          key: 1,
                          span: u.span ? u.span : 6
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(O, M({
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165"
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-select" ? (c(), g(C, {
                          key: 2,
                          span: u.span ? u.span : 6
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(j, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9"
                                }, u.formProps), {
                                  default: a(() => [
                                    (c(!0), $(I, null, J(u.formProps.options, (y) => (c(), g(T, {
                                      key: y.value,
                                      label: y.label,
                                      value: y.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" && !m(u).includes("range") ? (c(), g(C, {
                          key: 3,
                          span: u.span ? u.span : 6
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(R, M({
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  "range-separator": "\u81F3",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-date-picker" ? (c(), g(C, {
                          key: 4,
                          span: u.span ? u.span : 12
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(R, M({
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, {
                                  type: m(u)
                                }), null, 16, ["modelValue", "onUpdate:modelValue", "type"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" && !((le = u.formProps) != null && le.isRange) && !u.range ? (c(), g(C, {
                          key: 5,
                          span: u.span ? u.span : 6
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(x, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: ""
                                }, u.formProps), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-time-picker" ? (c(), g(C, {
                          key: 6,
                          span: u.span ? u.span : 12
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(x, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  clearable: ""
                                }, u.formProps, { "is-range": "" }), null, 16, ["modelValue", "onUpdate:modelValue"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : u.type === "el-radio-group" ? (c(), g(C, {
                          key: 7,
                          span: u.span ? u.span : 6
                        }, {
                          default: a(() => [
                            s(E, {
                              label: u.label
                            }, {
                              default: a(() => [
                                s(n, M({
                                  modelValue: e(t)[A],
                                  "onUpdate:modelValue": (y) => e(t)[A] = y,
                                  disabled: v(u, "disabled")
                                }, u.formProps), {
                                  default: a(() => [
                                    u.formProps.button ? z("", !0) : (c(!0), $(I, { key: 0 }, J(u.formProps.options, (y) => (c(), g(U, M({
                                      key: y.value,
                                      label: y.value
                                    }, u.formProps), {
                                      default: a(() => [
                                        q(ae(y.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label"]))), 128)),
                                    u.formProps.button ? (c(!0), $(I, { key: 1 }, J(u.formProps.options, (y) => (c(), g(k, M({
                                      key: y.value,
                                      label: y.value
                                    }, u.formProps), {
                                      default: a(() => [
                                        q(ae(y.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64);
                    }), 256)),
                    N(i.$slots, "search-form-bottom", {}, void 0, !0)
                  ]),
                  _: 3
                })
              ]),
              _: 3
            }, 8, ["model", "label-width"])
          ])
        ]),
        _: 3
      });
    };
  }
});
const fe = (o, p) => {
  const t = o.__vccOpts || o;
  for (const [f, b] of p)
    t[f] = b;
  return t;
}, ke = /* @__PURE__ */ fe(Ue, [["__scopeId", "data-v-c11eda56"]]), xe = { class: "edit" }, Le = { class: "edit_form" }, Ne = /* @__PURE__ */ ue({
  __name: "EditForm",
  props: {
    height: Number
  },
  setup(o) {
    const { Form_LabelWidth: p } = ne(), {
      editModel: t,
      Mode: f,
      ElementArrs: {
        value: { editor: b }
      },
      uploadFiles: m
    } = W(), v = ({ showFileList: D }) => {
      if (D)
        return !1;
      if (m[0])
        return URL.createObjectURL(m[0]);
    }, i = (D, E) => {
      if (E === "disabled")
        return typeof D.disabled == "function" ? D.disabled(W, f.value) : !1;
      if (E === "visible")
        return typeof D.visible == "function" ? D.visible(W, f.value) : !0;
    }, F = (D) => {
      let E = { ...D };
      return Object.keys(E).forEach((C) => {
        typeof E[C] == "function" && (E[C] = E[C].bind(this, W));
      }), E;
    };
    return (D, E) => {
      const C = _("el-input"), O = _("el-form-item"), T = _("el-col"), j = _("el-input-number"), R = _("el-option"), x = _("el-select"), U = _("el-date-picker"), k = _("el-time-picker"), n = _("el-cascader"), d = _("el-button"), h = _("el-image"), S = _("plus"), u = _("el-icon"), A = _("el-upload"), le = _("el-radio"), y = _("el-radio-button"), w = _("el-radio-group"), K = _("el-row"), de = _("el-form"), re = _("el-scrollbar");
      return c(), $("div", xe, [
        s(re, {
          height: o.height,
          "max-height": o.height
        }, {
          default: a(() => [
            G("div", Le, [
              N(D.$slots, "edit-form", { editModel: e(t) }, void 0, !0),
              s(de, {
                ref: "editFormRef",
                model: e(t),
                "label-width": e(p)
              }, {
                default: a(() => [
                  s(K, null, {
                    default: a(() => [
                      N(D.$slots, "edit-form-top", { editModel: e(t) }, void 0, !0),
                      (c(!0), $(I, null, J(e(b), (l, V) => (c(), $(I, { key: V }, [
                        l.type === "el-input" ? (c(), g(T, {
                          key: 0,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(C, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[V],
                                  "onUpdate:modelValue": (P) => e(t)[V] = P,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: i(l, "disabled")
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-input-number" ? (c(), g(T, {
                          key: 1,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(j, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[V],
                                  "onUpdate:modelValue": (P) => e(t)[V] = P,
                                  clearable: "",
                                  placeholder: "\u8BF7\u8F93\u5165",
                                  disabled: i(l, "disabled")
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-select" ? (c(), g(T, {
                          key: 2,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(x, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[V],
                                  "onUpdate:modelValue": (P) => e(t)[V] = P,
                                  clearable: "",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  disabled: i(l, "disabled")
                                }, l.formProps), {
                                  default: a(() => [
                                    (c(!0), $(I, null, J(l.formProps.options, (P) => (c(), g(R, {
                                      key: P.value,
                                      label: P.label,
                                      value: P.value
                                    }, null, 8, ["label", "value"]))), 128))
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-date-picker" ? (c(), g(T, {
                          key: 3,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(U, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[V],
                                  "onUpdate:modelValue": (P) => e(t)[V] = P,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: i(l, "disabled")
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-time-picker" ? (c(), g(T, {
                          key: 4,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(k, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[V],
                                  "onUpdate:modelValue": (P) => e(t)[V] = P,
                                  "start-placeholder": "\u5F00\u59CB",
                                  "range-separator": "\u81F3",
                                  "end-placeholder": "\u7ED3\u675F",
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  clearable: "",
                                  disabled: i(l, "disabled")
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-cascader" ? (c(), g(T, {
                          key: 5,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(n, M({
                                  style: { width: "100%" },
                                  modelValue: e(t)[V],
                                  "onUpdate:modelValue": (P) => e(t)[V] = P,
                                  props: l.formProps.props,
                                  placeholder: "\u8BF7\u9009\u62E9",
                                  "show-all-levels": !1,
                                  disabled: i(l, "disabled")
                                }, l.formProps), null, 16, ["modelValue", "onUpdate:modelValue", "props", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-upload" ? (c(), g(T, {
                          key: 6,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(A, M({
                                  style: { width: "100%" },
                                  ref_for: !0,
                                  ref: V + "UploadRef",
                                  action: ""
                                }, F(l.formProps)), {
                                  default: a(() => {
                                    var P;
                                    return [
                                      ((P = l.formProps) == null ? void 0 : P.listType) !== "picture-card" ? (c(), g(d, {
                                        key: 0,
                                        type: "primary"
                                      }, {
                                        default: a(() => [
                                          q(ae(l.formProps.butName || "\u70B9\u51FB\u4E0A\u4F20\u6587\u4EF6"), 1)
                                        ]),
                                        _: 2
                                      }, 1024)) : z("", !0),
                                      l.formProps.listType === "picture-card" && v(l.formProps) ? (c(), g(h, {
                                        key: 1,
                                        style: { width: "146px", height: "146px", "border-radius": "5px" },
                                        fit: "contain",
                                        src: v(l.formProps)
                                      }, null, 8, ["src"])) : z("", !0),
                                      l.formProps.listType == "picture-card" && !v(l.formProps) ? (c(), g(u, { key: 2 }, {
                                        default: a(() => [
                                          s(S)
                                        ]),
                                        _: 1
                                      })) : z("", !0)
                                    ];
                                  }),
                                  _: 2
                                }, 1040)
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : l.type === "el-radio-group" ? (c(), g(T, {
                          key: 7,
                          span: l.span ? l.span * 2 : 24
                        }, {
                          default: a(() => [
                            s(O, {
                              label: l.label,
                              prop: V,
                              rules: l.rules
                            }, {
                              default: a(() => [
                                s(w, M({
                                  modelValue: e(t)[V],
                                  "onUpdate:modelValue": (P) => e(t)[V] = P,
                                  disabled: i(l, "disabled")
                                }, l.formProps), {
                                  default: a(() => [
                                    l.formProps.button ? z("", !0) : (c(!0), $(I, { key: 0 }, J(l.formProps.options, (P) => (c(), g(le, M({
                                      key: P.value,
                                      label: P.value
                                    }, l.formProps), {
                                      default: a(() => [
                                        q(ae(P.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label"]))), 128)),
                                    l.formProps.button ? (c(!0), $(I, { key: 1 }, J(l.formProps.options, (P) => (c(), g(y, M({
                                      key: P.value,
                                      label: P.value
                                    }, l.formProps), {
                                      default: a(() => [
                                        q(ae(P.label), 1)
                                      ]),
                                      _: 2
                                    }, 1040, ["label"]))), 128)) : z("", !0)
                                  ]),
                                  _: 2
                                }, 1040, ["modelValue", "onUpdate:modelValue", "disabled"])
                              ]),
                              _: 2
                            }, 1032, ["label", "prop", "rules"])
                          ]),
                          _: 2
                        }, 1032, ["span"])) : z("", !0)
                      ], 64))), 128)),
                      N(D.$slots, "edit-form-bottom", { editModel: e(t) }, void 0, !0)
                    ]),
                    _: 3
                  })
                ]),
                _: 3
              }, 8, ["model", "label-width"])
            ])
          ]),
          _: 3
        }, 8, ["height", "max-height"])
      ]);
    };
  }
});
const $e = /* @__PURE__ */ fe(Ne, [["__scopeId", "data-v-653ba7a1"]]), ze = /* @__PURE__ */ q(" 123456 "), je = /* @__PURE__ */ ue({
  __name: "Table",
  props: {
    height: Number,
    Table_Attributes: Object
  },
  setup(o) {
    be();
    const p = L(null), { Table_isOpenMultipleSelection: t, Table_isOpenIndex: f, Table_isOpenExpand: b, Table_ExpandColumn: m, Table_MenuAlign: v, Table_MenuWidth: i, Page_PageParams: F } = ne(), {
      CompRef: D,
      tableData: E,
      tableLoading: C,
      ElementArrs: {
        value: { column: O }
      }
    } = W();
    ge(() => {
      D.value.TableRef = p.value;
    });
    const T = se(() => {
      var R, x;
      return (((R = F == null ? void 0 : F.value) == null ? void 0 : R.current) - 1) * ((x = F == null ? void 0 : F.value) == null ? void 0 : x.pageSize) + 1;
    }), j = (R, x) => {
      let U = { ...R };
      return Object.keys(U).forEach((k) => {
        typeof U[k] == "function" && (U[k] = U[k].call(this, W, x));
      }), U;
    };
    return (R, x) => {
      const U = _("el-empty"), k = _("el-table-column"), n = _("el-table"), d = he("loading");
      return ce((c(), g(n, M({
        ref_key: "TableRef",
        ref: p,
        height: o.height,
        data: e(E)
      }, o.Table_Attributes), {
        empty: a(() => [
          s(U, {
            "image-size": 80,
            description: "\u6682\u65E0\u6570\u636E"
          })
        ]),
        default: a(() => [
          e(t) ? (c(), g(k, {
            key: 0,
            type: "selection",
            "reserve-selection": "",
            width: 44
          })) : z("", !0),
          e(b) ? (c(), g(k, {
            key: 1,
            type: "expand",
            width: 55
          }, {
            default: a((h) => [
              ze
            ]),
            _: 1
          })) : z("", !0),
          e(f) ? (c(), g(k, {
            key: 2,
            label: "###",
            width: 55,
            "show-overflow-tooltip": ""
          }, {
            default: a(({ row: h, column: S, $index: u }) => [
              q(ae(e(T) + u), 1)
            ]),
            _: 1
          })) : z("", !0),
          (c(!0), $(I, null, J(e(O), (h, S) => (c(), g(k, M({
            key: S,
            align: h.align || "left"
          }, h.tableProps, {
            label: h.label,
            prop: S,
            "show-overflow-tooltip": ""
          }), ve({ _: 2 }, [
            h.columnSlot ? {
              name: "default",
              fn: a((u) => [
                (c(), g(Fe(h.columnSlot.is), Pe(Ee(j(h.columnSlot, u))), null, 16))
              ])
            } : void 0
          ]), 1040, ["align", "label", "prop"]))), 128))
        ]),
        _: 1
      }, 16, ["height", "data"])), [
        [d, e(C)]
      ]);
    };
  }
}), Ie = /* @__PURE__ */ ue({
  __name: "Pagination",
  setup(o) {
    const { queryRecord: p } = ye(), { Page_PageSizes: t, Page_PageParams: f, Page_Layout: b, Page_isHideOnSinglePage: m } = ne();
    function v(F) {
      f.value.pageSize = F, p();
    }
    function i(F) {
      f.value.current = F, f.value.current != null && p();
    }
    return (F, D) => {
      const E = _("el-pagination");
      return c(), g(E, {
        style: { "margin-top": "20px" },
        "hide-on-single-page": e(m),
        "current-page": e(f).current,
        "page-size": e(f).pageSize,
        "page-sizes": e(t),
        background: "",
        layout: e(b),
        total: e(f).total,
        onSizeChange: v,
        onCurrentChange: i
      }, null, 8, ["hide-on-single-page", "current-page", "page-size", "page-sizes", "layout", "total"]);
    };
  }
}), qe = { class: "button_left" }, Ke = /* @__PURE__ */ q(" \u65B0\u589E "), We = { class: "button_right" }, Qe = { style: { display: "flex", "justify-content": "flex-end" } }, Je = /* @__PURE__ */ q("\u53D6\u6D88"), Ge = /* @__PURE__ */ q("\u91CD\u7F6E"), Xe = /* @__PURE__ */ q("\u63D0\u4EA4"), Ye = /* @__PURE__ */ ue({
  __name: "index",
  props: {
    url: null,
    source: null,
    rowKey: null,
    rowKeys: null,
    keyName: null,
    watchData: null,
    hooks: null,
    debug: { type: Boolean, default: () => B.debug },
    mainMaxHeight: { default: () => B.mainMaxHeight },
    isAfterMountQuery: { type: Boolean, default: () => B.isAfterMountQuery },
    isOpenSearchForm: { type: Boolean, default: () => B.isOpenSearchForm },
    Form_LabelWidth: { default: () => B.Form_LabelWidth },
    Dialog_Width: { default: () => B.Dialog_Width },
    Dialog_isFullscreen: { type: Boolean, default: () => B.Dialog_isFullscreen },
    Dialog_isCloseOnPressEscape: { type: Boolean, default: () => B.Dialog_isCloseOnPressEscape },
    Dialog_isCloseOnClickModal: { type: Boolean, default: () => B.Dialog_isCloseOnClickModal },
    Dialog_isFooterButton: { type: Boolean, default: () => B.Dialog_isFooterButton },
    Table_Attributes: null,
    Table_isOpenIndex: { type: Boolean, default: () => B.Table_isOpenIndex },
    Table_isOpenMultipleSelection: { type: Boolean, default: () => B.Table_isOpenMultipleSelection },
    Table_isOpenExpand: { type: Boolean, default: () => B.Table_isOpenExpand },
    Table_ExpandColumn: { default: () => B.Table_ExpandColumn },
    Page_PageSizes: { default: () => B.Page_PageSizes },
    Page_PageParams: { default: () => B.Page_PageParams },
    Page_Layout: { default: () => B.Page_Layout },
    Page_isHideOnSinglePage: { type: Boolean, default: () => B.Page_isHideOnSinglePage },
    ApiName: { default: () => B.ApiName },
    Permission: { default: () => B.Permission },
    Permissions: { default: () => B.Permissions }
  },
  setup(o) {
    const p = L(), t = L(), f = L(), b = we(), { queryRecord: m, addRecord: v, refresh: i } = ye(), { CompRef: F, initSearchModel: D, Mode: E, DialogVisible: C, submitLoading: O, DialogVisibleFooterButton: T } = W(), { mainMaxHeight: j, isOpenSearchForm: R, Dialog_Width: x, Dialog_isFullscreen: U, Dialog_isCloseOnPressEscape: k, Dialog_isCloseOnClickModal: n, Permission: d, Permissions: h } = ne();
    if (b.params.data) {
      oe("\u8DEF\u7531\u4F20\u53C2\uFF1A", b.params.data);
      let w = b.params.data, K = JSON.parse(w);
      D.value = te(D.value, K);
    }
    const S = L(0), u = L(0), A = L(0);
    ge(() => {
      F.value.searchFormRef = p.value, F.value.buttonRef = t.value, F.value.paginationRef = f.value, S.value = F.value.searchFormRef.clientHeight, u.value = F.value.buttonRef.clientHeight, A.value = F.value.paginationRef.clientHeight;
    });
    const le = se(() => {
      const w = L(0);
      return console.log("main\u9AD8\u5EA6\uFF1A", j.value), console.log("\u641C\u7D22\u9AD8\u5EA6\uFF1A", S.value), console.log("\u6309\u94AE\u9AD8\u5EA6\uFF1A", u.value), console.log("\u5206\u9875\u9AD8\u5EA6\uFF1A", A.value + 20), R.value ? w.value = j.value - S.value - u.value - A.value - 40 - 20 : w.value = j.value - u.value - A.value - 40 - 20, console.log("\u8868\u683C\u9AD8\u5EA6", w.value), w.value;
    }), y = se(() => {
      const w = L(document.documentElement.clientHeight);
      return U.value ? w.value - 54 - 62 - 2 : w.value - 54 - 62 - 2 - w.value * 0.15 - 50;
    });
    return (w, K) => {
      const de = he("Auth");
      return c(), g(e(Be), null, {
        default: a(() => {
          var re;
          return [
            G("div", {
              ref_key: "searchFormRef",
              ref: p
            }, [
              ce(s(ke, null, {
                "search-form": a(() => [
                  N(w.$slots, "search-form", {}, void 0, !0)
                ]),
                "search-form-top": a(() => [
                  N(w.$slots, "search-form-top", {}, void 0, !0)
                ]),
                "search-form-bottom": a(() => [
                  N(w.$slots, "search-form-bottom", {}, void 0, !0)
                ]),
                _: 3
              }, 512), [
                [De, e(R)]
              ])
            ], 512),
            G("div", {
              ref_key: "buttonRef",
              ref: t,
              class: "button"
            }, [
              G("div", qe, [
                ce((c(), g(e(X), {
                  type: "primary",
                  icon: "plus",
                  onClick: e(v)
                }, {
                  default: a(() => [
                    Ke
                  ]),
                  _: 1
                }, 8, ["onClick"])), [
                  [de, { Permissions: e(h), access: [(re = e(d)) == null ? void 0 : re.add] }]
                ]),
                N(w.$slots, "button-left", {}, void 0, !0)
              ]),
              G("div", We, [
                N(w.$slots, "button-right", {}, void 0, !0),
                s(e(Me), { style: { "flex-shrink": "0", width: "150px" } }, {
                  default: a(() => [
                    s(e(X), {
                      color: "#67c23a",
                      icon: "search",
                      onClick: e(m)
                    }, null, 8, ["onClick"]),
                    s(e(X), {
                      color: "#e6a23c",
                      icon: "refresh",
                      onClick: e(i)
                    }, null, 8, ["onClick"]),
                    s(e(X), {
                      color: "#409eff",
                      icon: "expand",
                      onClick: K[0] || (K[0] = (l) => R.value = !e(R))
                    })
                  ]),
                  _: 1
                })
              ])
            ], 512),
            s(je, {
              height: e(le),
              Table_Attributes: o.Table_Attributes
            }, null, 8, ["height", "Table_Attributes"]),
            G("div", {
              ref_key: "paginationRef",
              ref: f
            }, [
              s(Ie)
            ], 512),
            s(e(Se), {
              class: "DialogVisible",
              modelValue: e(C),
              "onUpdate:modelValue": K[2] || (K[2] = (l) => Ve(C) ? C.value = l : null),
              title: e(E) === "add" ? "\u65B0\u589E" : "\u4FEE\u6539",
              width: e(x),
              "close-on-press-escape": e(k),
              fullscreen: e(U),
              "close-on-click-modal": e(n)
            }, ve({
              default: a(() => [
                s($e, { height: e(y) }, null, 8, ["height"])
              ]),
              _: 2
            }, [
              e(T) ? {
                name: "footer",
                fn: a(() => [
                  G("div", Qe, [
                    N(w.$slots, "edit-form-footer", {}, void 0, !0),
                    s(e(X), {
                      onClick: K[1] || (K[1] = (l) => C.value = !1)
                    }, {
                      default: a(() => [
                        Je
                      ]),
                      _: 1
                    }),
                    s(e(X), {
                      type: "warning",
                      plain: ""
                    }, {
                      default: a(() => [
                        Ge
                      ]),
                      _: 1
                    }),
                    s(e(X), {
                      type: "primary",
                      loading: e(O)
                    }, {
                      default: a(() => [
                        Xe
                      ]),
                      _: 1
                    }, 8, ["loading"])
                  ])
                ])
              } : void 0
            ]), 1032, ["modelValue", "title", "width", "close-on-press-escape", "fullscreen", "close-on-click-modal"])
          ];
        }),
        _: 3
      });
    };
  }
});
const pe = /* @__PURE__ */ fe(Ye, [["__scopeId", "data-v-6a8916b2"]]), Ze = {
  mounted(o, p, t) {
  }
};
pe.install = (o) => {
  o.component("CrudEl", pe), o.directive("Auth", Ze);
};
const ol = (o, p) => {
  p ? (p.CrudRequest || console.error("\u8BF7\u914D\u7F6E\u5168\u5C40\u8BF7\u6C42\u7684\u4E3B\u65B9\u6CD5\uFF1ACrudRequest"), Oe(p), o.use(pe)) : console.error("\u8BF7\u521D\u59CB\u5316CrudEl\u914D\u7F6E\u9879");
};
export {
  te as DataMerger,
  Q as DeepClone,
  Oe as InitSys,
  ol as createCrudEl,
  Y as hooksName,
  He as isObjEqual,
  Re as useHooks
};
